#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "symbolize2verb4xi.py">
#<abstract4xi abstract = "reads all programs in multiprocessing4xi and builds index for verb symbols in the system"/>
#<refer4xi reference = "Studio4Xi"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#       > go3studio4fb <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#       Tip: you could use the same go2studio4xi-command in all workstations just varying the content! 
#
# 2) make sure to run processed multiprocessing4xi library instead of temporary test library! 
#    - ack2temp should be False
#
# 3) > symbolize2verb4xi
#
# 4) view results
# 4a) generated HTML files in c4xi/profile/developer4xi/symbolize2verb4xi/index2symbol4xi.html
# 4b) STATISTICS in symbolize2verb4xi.txt
# 4c) *** ERROR in symbolize2verb4xi.txt
# 4d) ** WARNING in symbolize2verb4xi.txt 
#
# 5) modify multiprocessing4xi modules, if necessary
# 5a) verb2?4xi.py where ? = _,a,b,c ... z  
# 5b) verb4xi.py
#
# 6) create graphical symbols to verbs 
#
# 7) verify verb symbols against cluster and super 
# 
# 8) use verb symbols for multiprocessing4xi life cycles
#"
#/>
# ------------------------------------------------------------------------------------------------- 


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'symbolize2verb4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass

#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from time4xi import time4xi
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
from verb4xi import ClusterColor4Xi
from verb4xi import SuperClusterColor4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global kb2link4url
global index2name4url
global base2link
global number2cluster
global number2super

global default2language4translation
global base2find4translation
global base2generate4scipt
global base2source4animation
global width2frame4animation
global height2frame4animation


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2link = VersionKB4Xi['symbolize2verb4xi'] 
kb2link4url = {}
index2name4url = 0

start_tag4xi = '<verbalize4xi'
end_tag4xi   = '</verbalize4xi>'
path2source    = VersionKB4Xi['multiprocessing4xi']
path2verbalize = VersionKB4Xi['control2studio'] + "profile//developer4xi//symbolize2verb4xi//"
path2temp      = VersionKB4Xi['temp2studio']
linefeed = "\n"
separator2value = ";"
count2errors = 0

number2cluster = 2215
number2super = 2230


default2language4translation = "chinese"
base2find4translation = "http://www.archchinese.com/chinese_english_dictionary.html?find=xxxxxxxx"
base2generate4scipt = "http://www.archchinese.com/character_animation_creator.html"
base2source4animation = "view-source:http://www.archchinese.com/character_animation_creator.html"
width2frame4animation = 191
height2frame4animation = 216


#"
#"/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "symbolize2verb4xi" usage = "
#   creating symbols
#"> 
# -------------------------------------------------------------------------------------------------
def symbolize2verb4xi(param_FullName):
    global kb2link4url
    global index2name4url
    global base2link
    global number2cluster
    global number2super 
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------         
    
    name2xi=os.path.splitext(param_FullName)
    
    #print ('param_FullName: ' + param_FullName)
    #print ('name2xi[0]: ' + name2xi[0])
    #print ('name2xi[1]: ' + name2xi[1])
    
    # -------------------------------------------------------------------------------------------------    
    #
    # -------------------------------------------------------------------------------------------------         
      
    count_passed2xi = 0
    count_start_tag2xi = 0
    count_end_tag2xi = 0
    
    count_max_macrolines2xi = 33
    count2errors = 0    
    if name2xi[1] == '.py':
        # ---------------------------------------------------------------------------------------------
        # Python source files being explored
        # ---------------------------------------------------------------------------------------------    
        file2xi = name2xi[0]+'.py'
        input_file2xi = open(file2xi)                                # verb2_4xi.py
    
        # ---------------------------------------------------------------------------------------------
        # All lines in a source file
        # ---------------------------------------------------------------------------------------------
        while 1:
   
            # -----------------------------------------------------------------------------------------    
            # START OF LINE
            # -----------------------------------------------------------------------------------------     
       
 
            line2xi = input_file2xi.readline() 
            if not line2xi:

                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
            
                break                                                #all lines read, finish
            else:
            
                # -------------------------------------------------------------------------------------    
                # START OF LINE
                # -------------------------------------------------------------------------------------     

                count_macro_lines2xi = 0
                 
                # ------------------------------------------------------------------------------------
                # ANALYZE THE LINE
                # ------------------------------------------------------------------------------------             
                index2xi=str.find(line2xi,start_tag4xi)              # START-TAG 
                
                if index2xi == -1:
                    # ---------------------------------------------------------------------------------    
                    # SKIP NON-MACRO PART OF CODE
                    # --------------------------------------------------------------------------------- 
                    # print ('no verbalize-tag in line: ' + line2xi)                
                    count_passed2xi = count_passed2xi + 1
                else:                                                
                    # ---------------------------------------------------------------------------------    
                    # (STEP 1/33) START OF MACRO-HANDLING
                    # ---------------------------------------------------------------------------------                          
                    print ('(STEP 1A/33) OK: START-MACRO-TAG IN LINE: ' + line2xi)
                    index2xi=str.find(line2xi,">")
                    if index2xi == -1:
                        # -----------------------------------------------------------------------------    
                        #
                        # ----------------------------------------------------------------------------- 
                        print('(STEP 1Z/33) *** ERROR: > CHARACTER IS MISSING FOR THE START TAG IN LINE: ' + line2xi)
                        count_passed2xi = count_passed2xi + 1
                        count2errros = count2errors + 1
                        break
                    else:
                        # ----------------------------------------------------------------------------
                        # START TAG MET AND IT IS OK
                        # ----------------------------------------------------------------------------  
                        count_start_tag2xi = count_start_tag2xi + 1
                        name2verb = ""
                        count_macro_lines2xi = 0
                        
                        while 1:
                            # ------------------------------------------------------------------------------------
                            # CREATING VERB DOCUMENT READING MACRO LINE(S) UNTIL END TAG IS MET
                            # ------------------------------------------------------------------------------------                            
                            line2xi = input_file2xi.readline()         # 'zap':                   'zap',      
                            if not line2xi:                       
                                # ---------------------------------------------------------------------    
                                #
                                # ---------------------------------------------------------------------
                                break                                  # all lines read in file, finish
                            else:

                                # ---------------------------------------------------------------------    
                                # CONTINUING PROCESSING VERB DATA CLOSED WITH TAG
                                # ---------------------------------------------------------------------
                                index2xi=str.find(line2xi,end_tag4xi)  # END TAG ?
                                if index2xi == -1:
                                    if name2verb == "":
                                        # -------------------------------------------------------------    
                                        # (STEP 2/33) FIRST LINE OF VERB DEFINITIONS      
                                        # -------------------------------------------------------------                  
                                        index2start=str.find(line2xi,"'")
                                        index2end=str.find(line2xi,":")
                                        if (index2start == -1) or (index2end == -1):
                                            print("(STEP 2Z1/33) *** ERROR IN FILE: ", input_file2xi, ' INDEX2START: ', index2start, ' INDEX2END: ', index2end)
                                            count2errors = count2errors + 1
                                        else:
                                            name2verb = line2xi[index2start+1:index2end-1]
                                            print("(STEP 2A/33) line2xi: ", line2xi, " NAME2VERB: ", name2verb, " INDEX2START: ", index2start, " INDEX2END: ", index2end)         
                                            #          '_pertain':              '_pertain',
                                            count_macro_lines2xi = 1
                                            
                                            kb2tense = {}
                                            key2tense = 0
                                            kb2tense[key2tense] = name2verb
                                            key2tense = key2tense + 1
                                            
                                            kb2color = {}
                                            key2color = 0
                                            
                                            reference2verb = 0
                                            symbol2verb = 0
                                            cluster2verb = 0
                                            
                                            
                                    else:
                                        # -------------------------------------------------------------
                                        # LINE INSIDE TAG
                                        # -------------------------------------------------------------
                                        print("(STEP 3/33) EXAMINING LINE INSIDE TAG: ", line2xi)        
                                        #        'zapped':                'zapped', 
                                        #        'zapping':               'zapping',
                                        #        'reference-zapped':      2208,
                                        #        'definition-zap':        'to kill, shoot or destroy.',
                                        #        'symbol-zapping':        2208,
                                        #        'cluster-zapped':        6,
                                        #        'color-zap':             '#DF3838',
                                        #        'color-zapped':          '#EB6666',
                                        #        'color-zapping':         '#C71B1B',
                                        
                                        # 'definition-scope':      'to look at as in order to evaluate.',
                                                                                
                                        # ----------------------------------------------------------------------
                                        # COLOR-ATTRIBUTE ?
                                        # ----------------------------------------------------------------------
                                        pattern2key = "'color-"
                                        index2key4color=str.find(line2xi, pattern2key)
                                        #                                 01234567
                                        if index2key4color == -1:
                                            # ------------------------------------------------------------------
                                            # REFERENCE-ATTRIBUTE ?
                                            # ------------------------------------------------------------------
                                            pattern2reference = "'reference-"
                                            index2pattern=str.find(line2xi, pattern2reference)
                                            if index2pattern == -1:
                                                # --------------------------------------------------------------------------
                                                # SYMBOL-ATTRIBUTE ?
                                                # --------------------------------------------------------------------------
                                                pattern2symbol = "'symbol-"
                                                index2pattern=str.find(line2xi, pattern2symbol)
                                                if index2pattern == -1:
                                                    # --------------------------------------------------------------------------
                                                    # CLUSTER-ATTRIBUTE ?
                                                    # --------------------------------------------------------------------------
                                                    pattern2cluster = "'cluster-"
                                                    index2pattern=str.find(line2xi, pattern2cluster)
                                                    if index2pattern == -1:
                                                        # --------------------------------------------------------------------------
                                                        # DEFINITION-ATTRIBUTE ?
                                                        # --------------------------------------------------------------------------
                                                        pattern2definition = "'definition-"
                                                        index2pattern=str.find(line2xi, pattern2definition)
                                                        if index2pattern == -1:
                                                            # ----------------------------------------------------------------------
                                                            # (STEP 9/33) TENSE
                                                            # ---------------------------------------------------------------------- 
                                                            # 'showed':                'showed',
                                                            # 'showing':               'showing',
                                                            # 'shown':                 'shown',
                                                            
                                                            index2start=str.find(line2xi,"'")
                                                            index2end=str.find(line2xi,":")
                                                            if (index2start == -1) or (index2end == -1):
                                                                print("(STEP 9Z1/33) *** ERROR IN FILE: ", input_file2xi, ' INDEX2START: ', index2start, ' INDEX2END: ', index2end)
                                                                count2errors = count2errors + 1
                                                            else:
                                                                kb2tense[key2tense] = line2xi[index2start+1:index2end-1]
                                                                print("(STEP 9A/33) - TENSE ", key2tense, " ", kb2tense[key2tense], " DISCOVERED")
                                                                key2tense = key2tense + 1
                                                        else:
                                                            # =====================================================================
                                                            # (STEP 8/33) DEFINITION-ATTRIBUTE
                                                            # ===================================================================== 
                                                            #       'definition-serve':      'to provide with a regular or continious supply something.',
                                                            count_macro_lines2xi = count_macro_lines2xi + 1
                                                            source2definition = line2xi[index2pattern+len(pattern2definition):]
                                                            #       serve':      'to provide with a regular or continious supply something.',
                                                            pattern2end = "':"
                                                            index2start4definition=str.find(source2definition, pattern2end)
                                                            if index2start4definition ==  -1:
                                                                print("(STEP 8Z1/33) SOURCE2DEFINTION: ", source2definition, " *** ERROR INDEX2START4DEFINTION: ", index2start4definition)
                                                                count2errors = count2errors + 1    
                                                            else:
                                                                count2try = 0
                                                                max2count = 33
                                                                ack2found = False
                                                                source2definition = source2definition[index2start4definition+len(pattern2end):]
                                                                #            'to provide with a regular or continious supply something.',
                                                                index2start4definition = 0
                                                                while count2try < max2count:
                                                                    if source2definition[index2start4definition] == " ":
                                                                        index2start4definition = index2start4definition + 1
                                                                        count2try = count2try + 1
                                                                    else:
                                                                        ack2found = True
                                                                        break     
                                                                    if count2try == max2count:
                                                                       print("(STEP 8Z2/33) SOURCE2DEFINTION: ", source2definition, " *** ERROR COUNT2TRY: ", count2try)
                                                                       count2errors = count2errors + 1 
                                                                    else:
                                                                       pass
                                                                if ack2found is False:
                                                                    print("(STEP 8Z3/33) SOURCE2DEFINTION: ", source2definition, " *** ERROR ACK2FOUND: ", ack2found)
                                                                    count2errors = count2errors + 1 
                                                                else:        
                                                                    source2value = source2definition[index2start4definition:]   
                                                                    print("(STEP 8A/33) SOURCE2VALUE: ", source2value)
                                                                    #'to provide with a regular or continious supply something.',
                                                                    #'to add as an accessory, appendix or supplement.',
                                                                    index2start4value = 0
                                                                    pattern2end = ".',"
                                                                    index2end4value=str.find(source2value,pattern2end)
                                                                    if index2end == -1: 
                                                                        print("(STEP 8Z3/33) DEFINITION2VERB: ", definition2verb, " *** ERROR NOT ENDING TO: ", pattern2end4definition)
                                                                        count2errors = count2errors + 1
                                                                    else:
                                                                        definition2verb = source2value[index2start4value:index2end4value+2]
                                                                        print("(STEP 8B/33) DEFINTION2VERB: ", definition2verb)
                                                                        # 'to provide with a regular or continious supply something.'
                                                                        # 'to kill, shoot or destroy.'   
                                                    else:
                                                        # ======================================================================
                                                        # (STEP 7/33) CLUSTER-ATTRIBUTE
                                                        # ======================================================================
                                                        #       'cluster-saved':         20,
                                                        count_macro_lines2xi = count_macro_lines2xi + 1
                                                        source2cluster = line2xi[index2pattern+len(pattern2cluster):]
                                                        #       saved':         20,
                                                        pattern2end = "':"
                                                        index2start4cluster=str.find(source2cluster, pattern2end)
                                                        if index2start4cluster ==  -1:
                                                            print("(STEP 7Z1/33) SOURCE2CLUSTER: ", source2cluster, " *** ERROR INDEX2START4CLUSTER: ", index2start4cluster)
                                                            count2errors = count2errors + 1    
                                                        else:
                                                            count2try = 0
                                                            max2count = 33
                                                            ack2found = False
                                                            source2cluster = source2cluster[index2start4cluster+len(pattern2end):]
                                                            #      20,
                                                            index2start4cluster = 0
                                                            while count2try < max2count:
                                                                if source2cluster[index2start4cluster] == " ":
                                                                    index2start4cluster = index2start4cluster + 1
                                                                    count2try = count2try + 1
                                                                else:
                                                                    ack2found = True
                                                                    break     
                                                                if count2try == max2count:
                                                                   print("(STEP 7Z2/33) SOURCE2CLUSTER: ", source2cluster, " *** ERROR COUNT2TRY: ", count2try)
                                                                   count2errors = count2errors + 1 
                                                                else:
                                                                   pass
                                                            if ack2found is False:
                                                                print("(STEP 7Z3/33) SOURCE2CLUSTER: ", source2cluster, " *** ERROR ACK2FOUND: ", ack2found)
                                                                count2errors = count2errors + 1 
                                                            else:        
                                                                source2value = source2cluster[index2start4cluster:]   
                                                                #1759,
                                                                index2start4value = 0
                                                                pattern2end = ","
                                                                index2end4value=str.find(source2value,pattern2end)
                                                                if index2end == -1: 
                                                                    print("(STEP 7Z4/33) SOURCE2VALUE: ", source2value, " *** ERROR INDEX2END4VALUE: ", index2end4value)
                                                                    count2errors = count2errors + 1
                                                                else:
                                                                    cluster2verb = source2value[index2start4value:index2end4value]
                                                                    print("(STEP 7A/33) CLUSTER2VERB: ", cluster2verb)
                                                                    # 20 
                                                                    kb2verify = ClusterColor4Xi[int(cluster2verb)]
                                                                    if kb2verify [6] == 'FREE':
                                                                        print("(STEP 7Z5/33) ** WARNING ** REFERRED CLUSTER2VERB: ", cluster2verb, " NAME: ", kb2verify [6])
                                                                    else:
                                                                        pass        
                                                else:
                                                    # ======================================================================
                                                    # (STEP 6/33) SYMBOL-ATTRIBUTE
                                                    # ====================================================================== 
                                                    #       'symbol-saving':         1707,
                                                    count_macro_lines2xi = count_macro_lines2xi + 1
                                                    source2symbol = line2xi[index2pattern+len(pattern2symbol):]
                                                    #       saving':         1707,
                                                    pattern2end = "':"
                                                    index2start4symbol=str.find(source2symbol, pattern2end)
                                                    if index2start4symbol ==  -1:
                                                        print("(STEP 6Z1/33) SOURCE2SYMBOL: ", source2symbol, " *** ERROR INDEX2START4SYMBOL: ", index2start4symbol)
                                                        count2errors = count2errors + 1    
                                                    else:
                                                        count2try = 0
                                                        max2count = 33
                                                        ack2found = False
                                                        source2symbol = source2symbol[index2start4symbol+len(pattern2end):]
                                                        #      1707,
                                                        index2start4symbol = 0
                                                        while count2try < max2count:
                                                            if source2symbol[index2start4symbol] == " ":
                                                                index2start4symbol = index2start4symbol + 1
                                                                count2try = count2try + 1
                                                            else:
                                                                ack2found = True
                                                                break     
                                                            if count2try == max2count:
                                                               print("(STEP 6Z2/33) SOURCE2SYMBOL: ", source2symbol, " *** ERROR COUNT2TRY: ", count2try)
                                                               count2errors = count2errors + 1 
                                                            else:
                                                               pass
                                                        if ack2found is False:
                                                            print("(STEP 6Z3/33) SOURCE2SYMBOL: ", source2symbol, " *** ERROR ACK2FOUND: ", ack2found)
                                                            count2errors = count2errors + 1 
                                                        else:        
                                                            source2value = source2symbol[index2start4symbol:]   
                                                            #1759,
                                                            index2start4value = 0
                                                            pattern2end = ","
                                                            index2end4value=str.find(source2value,pattern2end)
                                                            if index2end == -1: 
                                                                print("(STEP 6Z3/33) SOURCE2VALUE: ", source2value, " *** ERROR INDEX2END4VALUE: ", index2end4value)
                                                                count2errors = count2errors + 1
                                                            else:
                                                                symbol2verb = source2value[index2start4value:index2end4value]
                                                                print("(STEP 6A/33) SYMBOL2VERB: ", symbol2verb)
                                                                # 1707
                                            else:
                                                # ==============================================================
                                                # STEP 5/33) REFERENCE-ATTRIBUTE
                                                # ==============================================================
                                                #       'reference-shared':      1759,
                                                ack2reference = True
                                                count_macro_lines2xi = count_macro_lines2xi + 1
                                                source2reference = line2xi[index2pattern+len(pattern2reference):]
                                                #       shared':      1759,
                                                pattern2end = "':"
                                                index2start4reference=str.find(source2reference, pattern2end)
                                                if index2start4reference ==  -1:
                                                    print("(STEP 5Z1/33) SOURCE2REFERENCE: ", source2reference, " *** ERROR INDEX2START4REFERENCE: ", index2start4reference)
                                                    count2errors = count2errors + 1    
                                                else:
                                                    count2try = 0
                                                    max2count = 33
                                                    ack2found = False
                                                    source2reference = source2reference[index2start4reference+len(pattern2end):]
                                                    #      1759,
                                                    index2start4reference = 0
                                                    while count2try < max2count:
                                                        if source2reference[index2start4reference] == " ":
                                                            index2start4reference = index2start4reference + 1
                                                            count2try = count2try + 1
                                                        else:
                                                            ack2found = True
                                                            break     
                                                        if count2try == max2count:
                                                           print("(STEP 5Z2/33) SOURCE2REFERENCE: ", source2reference, " *** ERROR COUNT2TRY: ", count2try)
                                                           count2errors = count2errors + 1 
                                                        else:
                                                           pass
                                                    if ack2found is False:
                                                        print("(STEP 5Z3/33) SOURCE2REFERENCE: ", source2reference, " *** ERROR ACK2FOUND: ", ack2found)
                                                        count2errors = count2errors + 1 
                                                    else:        
                                                        source2value = source2reference[index2start4reference:]   
                                                        #1759,
                                                        index2start4value = 0
                                                        pattern2end = ","
                                                        index2end4value=str.find(source2value,pattern2end)
                                                        if index2end == -1: 
                                                            print("(STEP 5Z3/33) SOURCE2VALUE: ", source2value, " *** ERROR INDEX2END4VALUE: ", index2end4value)
                                                            count2errors = count2errors + 1
                                                        else:
                                                            reference2verb = source2value[index2start4value:index2end4value]
                                                            print("(STEP 5A/33) REFERENCE2VERB: ", reference2verb)
                                                            # 1707
                                        else:
                                            # ==================================================================
                                            # (STEP 4/33) COLOR ATTRIBUTE
                                            # ==================================================================
                                            #        'color-zap':             '#DF3838',
                                            count_macro_lines2xi = count_macro_lines2xi + 1
                                            
                                            index2start4color=str.find(line2xi[len(pattern2key):],"'#")
                                            if index2start4color == -1: 
                                                print("(STEP 4Z1/33) LINE2XI: ", line2xi, " *** ERROR  INDEX2START4COLOR: ", index2start4color)
                                                count2errors = count2errors + 1
                                            else:
                                                source2value = line2xi[len(pattern2key):]  
                                                print("(STEP 4A/33) SOURCE2VALUE: ", source2value)
                                                # '#DF3838',
                                                index2start4value=str.find(source2value,"'#")
                                                if index2start4value == -1: 
                                                    print("(STEP 4Z2/33) LINE2XI: ", line2xi, " *** ERROR INDEX2START4VALUE: ", index2start4value)
                                                    count2errors = count2errors + 1
                                                else:
                                                    kb2color[key2color] = source2value[index2start4value:index2start4value+9]
                                                    print("(STEP 4B/33) KB2COLOR[", key2color,"]: ", kb2color[key2color])
                                                    key2color = key2color + 1
                                                
                                                # (STEP 2B/33) EXAMINING VERB DEFINITION LINE:         'color-zap':             '#DF3838',
                                                # (STEP 2C/33) SOURCE2VALUE:  'color-zap':             '#DF3838',
                                                # (STEP 2D/33) KB2COLOR[ 0 ]:  '#DF3838'
                                                # (STEP 2B/33) EXAMINING VERB DEFINITION LINE:         'color-zapped':          '#EB6666',
                                                # (STEP 2C/33) SOURCE2VALUE:  'color-zapped':          '#EB6666',
                                                # (STEP 2D/33) KB2COLOR[ 1 ]:  '#EB6666'
                                                # (STEP 2B/33) EXAMINING VERB DEFINITION LINE:         'color-zapping':         '#C71B1B',              
                                                # (STEP 2C/33) SOURCE2VALUE:  'color-zapping':         '#C71B1B',              
                                                # (STEP 2D/33) KB2COLOR[ 2 ]:  '#C71B1B'
                                                


                                        
                                else:
                                    # -----------------------------------------------------------------    
                                    # END-TAG
                                    # -----------------------------------------------------------------  
                                    print ('(STEP 19/33) OK: END-MACRO-TAG IN LINE : ' + line2xi)
                                    count_end_tag2xi = count_end_tag2xi + 1
                                    break                           

                                # ---------------------------------------------------------------------    
                                # FINISHING LINES FOR MACRO
                                # ---------------------------------------------------------------------
                                           
                            # ------------------------------------------------------------------------------------
                            # POSSIBLY SET NAME TO VERB
                            # ------------------------------------------------------------------------------------                                     
                            
                        # ------------------------------------------------------------------------------------
                        # SAVE VERB ATTRIBUTES TO HTML FILE
                        # ------------------------------------------------------------------------------------                      
                        if count_macro_lines2xi == 0:
                            break
                        else:
                            # ---------------------------------------------------------------------   
                            # PRODUCE OUTPUT HTML FILE USING SYMBOL AS NAME 
                            # ---------------------------------------------------------------------     
                            path2verb = path2verbalize + symbol2verb + '.html'
                            try:
                                # -----------------------------------------------------------------
                                # (STEP 20/33) SAVE LINK TO VERB NAME
                                # -----------------------------------------------------------------
                                key2alpha = name2verb[0]
                                key2alpha = key2alpha.lower() 
                                print("(STEP 20A/33) KEY2ALPHA: ", key2alpha, " PATH2VERB: ", path2verb) 
                                # KEY2ALPHA:  a  PATH2VERB:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//3.html
                                
                                if kb2link4url == {}:
                                    kb2link4url[key2alpha] = {}
                                    kb2link4url[key2alpha] [name2verb] = path2verb
                                    print("(STEP 20C/33) kb2link4url[", key2alpha, "][", name2verb, "]: ", kb2link4url[key2alpha] [name2verb])
                                    # kb2link4url[ a ][ abbreviate ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//3.html
                                                                  
                                else:
                                    keys2alpha = kb2link4url.keys()
                                    if key2alpha in keys2alpha:                                     
                                        kb2link4url[key2alpha] [name2verb] = path2verb
                                        print("(STEP 20E/33) kb2link4url[", key2alpha, "][", name2verb, "]: ", kb2link4url[key2alpha] [name2verb])
                                        # kb2link4url[ s ][ scheme ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//scheme.html
                                        
                                    else:
                                        kb2link4url[key2alpha] = {}
                                        kb2link4url[key2alpha] [name2verb] = path2verb
                                        print("(STEP 20G/33) kb2link4url[", key2alpha, "][", name2verb, "]: ", kb2link4url[key2alpha] [name2verb])
                                        # kb2link4url[ z ][ zap ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//zap.html
                                        
                            except:
                                print("(STEP 20Z/33) *** FAILED TO SAVE LINK TO NAME ", path2verb)
                                # 
                            try:           
                                # -----------------------------------------------------------------
                                # (STEP 21A/33) OPEN OUTPUT HTML FILE
                                # -----------------------------------------------------------------
                                   
                                f2xi=open(path2verb, 'w')    
                                print("(STEP 21A/33) OK: OPENED FOR WRITING PATH2VERB: ", path2verb, time4xi())
                                # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//3.html
                            except:
                                print("(STEP 21ZA/33) *** FAILED TO OPEN OUTPUT HTMl FILE ", time4xi()) 
                            try:        
                                # -----------------------------------------------------------------
                                # (STEP 21B/33) WRITE START OF HTML CONTENT
                                # -----------------------------------------------------------------
                                f2xi.write('<!DOCTYPE HTML>' + '\n')
                                f2xi.write('<html>' + '\n')
                                f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
                                f2xi.write('<style type="text/css" media="all">' + '\n')
                                f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
                                f2xi.write('</style>' + '\n') 
                                f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
                                f2xi.write('<body>' + '\n')
                                
                                f2xi.write('<h3>' + 'Verb Info ' + '[Rel 7.21] ' + '[' + time4xi() + ']' + '</h3>' + '\n')
                                
                                f2xi.write('<body>' + '\n')
                            except:
                                print("(STEP 21ZB/33) *** FAILED TO WRITE START OF HTML CONTENT ", time4xi()) 
                            try:    
                                # -----------------------------------------------------------------
                                # (STEP 21C/33) WRITE START OF TABLE
                                # ----------------------------------------------------------------- 
                                f2xi.write('<table>' + '\n')
                                f2xi.write('<tbody>' + '\n')
                                f2xi.write('<tr>' + '\n') 
                                f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n')
                                f2xi.write('</td>' + '\n')
                                f2xi.write('</tr>' + '\n')
                                                                
                            except:
                                print("(STEP 21ZC/33) *** FAILED TO WRITE START OF TABLE ", time4xi()) 
                            try:                                     
                                # -----------------------------------------------------------------
                                # (STEP 21D/33) WRITE TENSES
                                # -----------------------------------------------------------------
                                # show;
                                keys2tense = kb2tense.keys()
                                 
                                for key2tense in sorted(keys2tense):
                                    f2xi.write('<tr>' + '\n')
                                    f2xi.write('<td>' + '\n')
                                    f2xi.write('verb-tense' + str(key2tense+1) + '\n')
                                    f2xi.write('</td>' + '\n')
                                    f2xi.write('<td>' + '\n')
                                    f2xi.write(kb2tense[key2tense] + '\n')
                                    f2xi.write('</td>' + '\n')
                                    f2xi.write('</tr>' + '\n') 
                            except:
                                print("(STEP 21ZD/33) *** FAILED TO WRITE TENSES ", time4xi()) 
                            try:            
                                # ------------------------------------------------------------------
                                # (STEP 22/33) WRITE COLORS FOR TENSES 1,2,3(ALWAYS) and 4(OPTIONAL)
                                # ------------------------------------------------------------------
                                # show;'#BFF9E7';'#E3FAF3';'#96EFD4';'#F0FDF9'
                                keys2colors = kb2color.keys()
                                
                                for key2color in keys2colors:
                                    f2xi.write('<tr>' + '\n')
                                    f2xi.write('<td>' + '\n')
                                    f2xi.write('verb-color' + str(key2color+1) + '\n')
                                    f2xi.write('</td>' + '\n')
                                    f2xi.write('<td bgcolor=' + str(kb2color[key2color]) + '>' + '\n')
                                    f2xi.write('</td>' + '\n')
                                    f2xi.write('</tr>' + '\n') 
                            except:
                                print("(STEP 22Z1/33) *** FAILED TO WRITE COLORS FOR TENSES  ", time4xi()) 
                            try:       
                                # ------------------------------------------------------------------
                                # (STEP 23/33) WRITE REFERENCE NUMBER FOR VERB
                                # ------------------------------------------------------------------
                                # previous version:
                                # f2xi.write('<br />' + 'verb-reference: '+reference2verb + '\n')
                                # 1772
                                f2xi.write('<tr>' + '\n')
                                f2xi.write('<td>' + '\n')
                                f2xi.write('verb-reference' + '\n')
                                f2xi.write('</td>' + '\n')
                                f2xi.write('<td>' + '\n')
                                f2xi.write(reference2verb + '\n')
                                f2xi.write('</td>' + '\n')
                                f2xi.write('</tr>' + '\n')
                                # 3
                            except:
                                print("(STEP 23Z1/33) *** FAILED TO WRITE REFERENCE NUMBER ", time4xi()) 
                            try:       
                                
                                # ------------------------------------------------------------------
                                # (STEP 24/33) WRITE SYMBOL NUMBER AS PNG FOR VERB
                                # ------------------------------------------------------------------
                                # previous version:
                                # f2xi.write('<br />' + 'verb-symbol: '+symbol2verb + '\n')
                                # 1772
                                
                                f2xi.write('<tr>' + '\n')
                                
                                f2xi.write('<td>' + '\n')
                                f2xi.write('verb-symbol' + '\n')
                                f2xi.write('</td>' + '\n')
                                
                                len2symbol = len(str(symbol2verb)) 
                                print("(STEP 24A/33) LEN2SYMBOL: ", len2symbol, " SYMBOL2VERB: ", symbol2verb, " STR-SYMBOL2VERB: ", str(symbol2verb))  
                                # LEN2SYMBOL:  1  SYMBOL2VERB:  3  STR-SYMBOL2VERB:  3
                                key2symbol = 0
                                
                                f2xi.write('<td>' + '\n')
                                while key2symbol < len2symbol:
                                    # <img src="https://www.yourdragonxi.org/web/images/png/1_q.png">
                                    print("(STEP 24B/33) SYMBOL2VERB[", key2symbol, "]: ", symbol2verb[key2symbol])
                                    
                                    # line2write = '<img src="https://www.yourdragonxi.org/web/images/png/' + str(symbol2verb[key2symbol]) + '_q.png">' + '\n'
                                    # print("(STEP 24C/33) LINE2WRITE ", line2write)
                                    
                                    f2xi.write('<img src="https://www.yourdragonxi.org/web/images/png/' + str(symbol2verb[key2symbol]) + '_q.png">' + '\n')
                                    
                                    key2symbol = key2symbol + 1
                                    
                                f2xi.write('</td>' + '\n')
                                f2xi.write('</tr>' + '\n') 
                                
                            except:
                                print("(STEP 24Z1/33) *** FAILED TO WRITE SYMBOL NUMBER AS PNG ", time4xi()) 
                            try:       
                                # ------------------------------------------------------------------
                                # (STEP 30/33) WRITE CLUSTER NUMBER FOR VERB
                                # ------------------------------------------------------------------
                                f2xi.write('<tr>' + '\n')
                                f2xi.write('<td>' + '\n')
                                f2xi.write('verb-cluster' + '\n')
                                f2xi.write('</td>' + '\n')
                                f2xi.write('<td>' + '\n')
                                f2xi.write(cluster2verb + '\n')
                                f2xi.write('</td>' + '\n')
                                f2xi.write('</tr>' + '\n')
                                
                                
                                # ClusterColor4Xi = {
                                #       TENSE 1       TENSE 2       TENSE 3       TENSE 4   #SUPER #CLUSTER                             # VERB EXAMPLES
                                #       BASE          STRONGER      LIGHTER       STRONGEST     INDEX NAME 
                                print("(STEP 30A/33) STARTING CLUSTER ", cluster2verb, " PROCESSING FOR: ", path2verb)  
                                # STARTING CLUSTER  19  PROCESSING FOR:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//3.html
                                # 
                                key2link4cluster = int(cluster2verb)
                                print("(STEP 30B/33) KEY2LINK4CLUSTER: ", key2link4cluster)
                                # 21
                                kb2use4cluster = ClusterColor4Xi[key2link4cluster]
                                print("(STEP 30C/33) kb2use4cluster: ", kb2use4cluster)
                                # {1: '#BA82EB', 2: '#8B61AF', 3: '#B47EE4', 4: '#815AA2', 5: 8, 6: 'documentation'}
                                keys2use4cluster = kb2use4cluster.keys()
                                print("(STEP 30D/33) KEYS2USE4CLUSTER: ", keys2use4cluster)
                                # dict_keys([1, 2, 3, 4, 5, 6])
                                
                            except:
                                print("(STEP 30Z1/33) *** FAILED TO WRITE CLUSTER NUMBER ", time4xi()) 
                            try:       
                                # ------------------------------------------------------------------
                                # (STEP 31/33) WRITE CLUSTER TENSE AND ITS COLOR FOR VERB
                                # ------------------------------------------------------------------
                                
                                for key2use4cluster in keys2use4cluster:
                                    if ((key2use4cluster < 5) and (key2use4cluster > 0)): 
                                        try:
                                            print("(STEP 31A/33) KEY2USE4CLUSTER: ", key2use4cluster, " KB2USE4CLUSTER[", key2use4cluster,"]", kb2use4cluster[key2use4cluster])
                                            # {1: '#9BA2A2', 2: '#8E9292', 3: '#DAE1E1', 4: '#DAE1E2', 5: 'theater'}
                                            # KEY2USE4CLUSTER:  1  KB2USE4CLUSTER[ 1 ] #356C6C
                                            # KEY2USE4CLUSTER:  2  KB2USE4CLUSTER[ 2 ] #2C5858
                                            # KEY2USE4CLUSTER:  3  KB2USE4CLUSTER[ 3 ] #6ED1D1
                                            # KEY2USE4CLUSTER:  4  KB2USE4CLUSTER[ 4 ] #244747
                                            f2xi.write('<tr>' + '\n')
                                            f2xi.write('<td>' + '\n')
                                            f2xi.write('cluster-tense' + str(key2use4cluster) + '-color' + '\n')
                                            f2xi.write('</td>' + '\n')
                                            f2xi.write('<td bgcolor=' + str(kb2use4cluster[key2use4cluster]) + '>' + '\n')
                                            f2xi.write('</td>' + '\n')
                                            f2xi.write('</tr>' + '\n')
                                        except:
                                            print("(STEP 31Z1/33) *** FAILED IN CLUSTER PROCESSING KEY2USE4CLUSTER: ", key2use4cluster, " KB2USE4CLUSTER: ", kb2use4cluster, "PATH: ", path2verb)
                                            # KEY2USE4CLUSTER:  1  KB2USE4CLUSTER:  {1: '#356C6C', 2: '#2C5858', 3: '#6ED1D1', 4: '#244747', 5: 8, 6: 'dataflow'} PATH:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//save.html
   
                                       
                                    if key2use4cluster == 5:
                                        print("(STEP 31B/33) KEY2USE4CLUSTER: ", key2use4cluster)
                                        # 
                                        key2link5super = kb2use4cluster[key2use4cluster]
                                        print("(STEP 31C/33) KEY2LINK5SUPER: ", key2link5super)
                                        # 5
                                        
                                        f2xi.write('<tr>' + '\n')
                                        f2xi.write('<td>' + '\n')
                                        f2xi.write('cluster-super' + '\n')
                                        f2xi.write('</td>' + '\n')
                                        f2xi.write('<td>' + '\n')
                                        f2xi.write(str(key2link5super) + '\n')
                                        f2xi.write('</td>' + '\n')
                                        f2xi.write('</tr>' + '\n')
                                        
                                        # SuperClusterColor4Xi = {
                                        #       NETWORK-CENTRIC OPERATIONS AT REMOTE AND DEMANDING THEATERS
                                        #       TENSE 1       TENSE 2       TENSE 3       TENSE 4       #NAME                 
                                        #       BASE          STRONGER      LIGHTER       STRONGEST
                                        # 1:  {1: '#9BA2A2', 2: '#8E9292', 3: '#DAE1E1', 4: '#DAE1E2', 5: 'theater'},
                                        # ...   
                                        kb2use4super = SuperClusterColor4Xi[key2link5super] 
                                        print("(STEP 31D/33) KB2USE4SUPER: ", kb2use4super)
                                        # {1: '#DE9ABC', 2: '#BF749A', 3: '#B3698E', 4: '#9C5378', 5: 'miscellaneous'}
                                         
                                        keys2use4super =  kb2use4super.keys()
                                        print("(STEP 31E/33) KEYS2USE4SUPER: ", keys2use4super)
                                        # dict_keys([1, 2, 3, 4, 5])
                                        
                                        
                                        for key2use4super in keys2use4super:
                                            if key2use4super < 5:
                                                try:
                                                    print("(STEP 31F/33) KEY2USE4SUPER: ", key2use4super)
                                                    # 1
                                                    f2xi.write('<tr>' + '\n')
                                                    
                                                    f2xi.write('<td>' + '\n')
                                                    f2xi.write('super-color' + str(key2use4super) + '\n')
                                                    f2xi.write('</td>' + '\n')
                                                    
                                                    f2xi.write('<td bgcolor=' + str(kb2use4super[key2use4super]) + '>' + '\n')
                                                    f2xi.write('</td>' + '\n')
                                                    
                                                    f2xi.write('</tr>' + '\n')
                                                    # super-color1: '#9292A1'
                                                    # super-color4: '#2A2A5C'
                                                    # super-color5: '#B2B2BF'
                                                    # super-color6: '#11112B'
                                                    
                                                except:
                                                    print("(STEP 31ZF/33) *** FAILED IN SUPER-CLUSTER PROCESSING, KEY2USE4SUPER: ", key2use4super, " FOR: ", path2verb) 
                                            if key2use4super == 5:
                                                
                                                try:
                                                    print("(STEP 31G/33) KEY2USE4SUPER: ", key2use4super, "SUPER-NAME: ", str(kb2use4super[key2use4super]))
                                                    # 5 SUPER-NAME:  miscellaneous
                                                    f2xi.write('<tr>' + '\n')
                                                    
                                                    f2xi.write('<td>' + '\n') 
                                                    f2xi.write('super-name' + '\n')
                                                    f2xi.write('</td>' + '\n')
                                                    
                                                    f2xi.write('<td>' + '\n') 
                                                    f2xi.write(str(kb2use4super[key2use4super]) + '\n')
                                                    # 'operations'
                                                    f2xi.write('<td>' + '\n')
                                                    
                                                    f2xi.write('</tr>' + '\n')
                                                except:
                                                    print("(STEP 31ZG/33) *** FAILED IN SUPER-CLUSTER PROCESSING FOR: ", path2verb)     
                                                 
                                    if key2use4cluster == 6:
                                        
                                        
                                        print("(STEP 31H/33) KEY2USE4CLUSTER: ", key2use4cluster)
                                        # 6
                                        f2xi.write('<tr>' + '\n')
                                        f2xi.write('<td>' + '\n')
                                        f2xi.write('cluster-name' + '\n')
                                        f2xi.write('</td>' + '\n')
                                        f2xi.write('<td>' + '\n')
                                        f2xi.write(str(kb2use4cluster[key2use4cluster]) + '\n')
                                        f2xi.write('</td>' + '\n')
                                        f2xi.write('</tr>' + '\n')
                            except:
                                print("(STEP 31ZH/33) *** FAILED TO WRITE CLUSTER TENSE AND ITS COLOR ", time4xi()) 
                            try:                                   
                                
                                # ------------------------------------------------------------------
                                # (STEP 32/33) WRITE REST FOR VERB
                                # ------------------------------------------------------------------
                                print("(STEP 32A/33) OK - WRITING REST OF OUTPUT FILE: ", path2verb)
                                # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//3.html
                                f2xi.write('<tr>' + '\n')
                                f2xi.write('<td>' + '\n')
                                f2xi.write('verb-definition' + '\n')
                                f2xi.write('</td>' + '\n') 
                                f2xi.write('<td>' + '\n')
                                f2xi.write(definition2verb + '\n')
                                f2xi.write('</td>' + '\n') 
                                f2xi.write('</tr>' + '\n')              
                                 
                                f2xi.write('<tr>' + '\n') 
                                f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n') 
                                f2xi.write('</td>' + '\n') 
                                f2xi.write('</tr>' + '\n') 
                                f2xi.write('</tbody>' + '\n') 
                                f2xi.write('</table>' + '\n') 
                                                  
                                f2xi.write('</body>' + '\n')
                                f2xi.write('</html>' + '\n')
                            except:
                                print("(STEP 32Z1/33) *** FAILED TO WRITE REST ", time4xi()) 
                            try:            
                                # ---------------------------------------------------------------------   
                                # (STEP 33/33) CLOSE OUTPUT HTML FILE FOR VERB
                                # ---------------------------------------------------------------------           
                                print("(STEP 33A/33) OK - PRODUCED OUTPUT FILE: ", path2verb)
                                # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//3.html
                                f2xi.close()
                                print("(STEP 33B/33) OK - CLOSED PATH2VERB: ", path2verb)
                                # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//3.html                         
                            except:
                                print("(STEP 33Z1/33) *** FAILED TO CLOSE OUTPUT HTML FILE ", time4xi())    
                            
                    # ---------------------------------------------------------------------------------    
                    # END OF MACRO-HANDLING
                    # ---------------------------------------------------------------------------------          
                # -------------------------------------------------------------------------------------    
                # END OF LINE
                # -------------------------------------------------------------------------------------     

            # -----------------------------------------------------------------------------------------    
            # EOF LINES
            # -----------------------------------------------------------------------------------------     
                        
        # ---------------------------------------------------------------------------------------------
        # (STEP 33/33) END OF SOURCE FILE
        # ---------------------------------------------------------------------------------------------
        print(33*("="))
        print ("(STEP 33A/33) STATISTICS FOR INPUT_FILE2XI: ", input_file2xi) 
        # <_io.TextIOWrapper name='..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//verb2a4xi.py' mode='r' encoding='cp1252'>
        print ('- PASSED LINES:     ', count_passed2xi)
        print ('- START MACRO TAGS: ', count_start_tag2xi)
        print ('- END MACRO TAGS:   ', count_end_tag2xi)
        # - PASSED LINES:      118
        # - START MACRO TAGS:  12
        # - END MACRO TAGS:    12        
        
        if (count_start_tag2xi < count_end_tag2xi) or (count_start_tag2xi > count_end_tag2xi):
            print("(STEP 33Z1/33) *** ERROR IN FILE: ", input_file2xi)
            print("(STEP 33Z2/33) *** start-tags: ", count_start_tag2xi)
            print("(STEP 33Z3/33) *** end-tags: ", count_end_tag2xi)           

  
        if count2errors > 0:
            print("(STEP 33Z4/33) *** ERROR IN FILE: ", input_file2xi)
            print("(STEP 33Z5/33) *** COUNT2ERRORS: ", count2errors)    
                       
        print(33*("="))
            
#</function4xi>    

# =================================================================================================
#<class4xi class = "DirectoryWalker4Xi" base = "None" child = "None" 
#   synopsis = "a forward iterator that traverses a directory tree"
#   usage = "traversing a directory tree"
#>
# =================================================================================================
class DirectoryWalker4Xi:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker4Xi"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "gets item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            try:
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # pop next directory from stack
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # got a filename
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
    
#</class4xi>        
    
# -------------------------------------------------------------------------------------------------
##<function4xi function = "main" usage = "
#   main function of symbolize2verb4xi.py
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global base2link
    global kb2link4url
    global index2name4url
    
    print('=' *70)
  
    ack2temp = False                                                  # only few source files to test this module
    if ack2temp is True:
        path2source = path2temp
        print("(STEP 0A/33) Verbalize4Xi: CREATING ONLY FEW VERB-DOCUMENTS FROM ", path2source)
        # 
    else: 
        path2source  = VersionKB4Xi['multiprocessing4xi']  
        print("(STEP 0B/33) Verbalize4Xi: CREATING FINAL VERB-DOCUMENTS FROM ", path2source) 
        # ..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//ace_object4xi.py 
    print('=' *70)
    
    ack2skip = False    
    if ack2skip is True:
        pass
    else:    
        for file2xi in DirectoryWalker4Xi(path2source):
            if os.path.isdir(file2xi):
                print ("(STEP 0C/33) DIRECTORY: " + file2xi + '\n')
                # ..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//dummy
            if os.path.isfile(file2xi):
                print ("(STEP 0D/33) VERBALIZE4XI: INPUT FILE: " + file2xi + '\n')
                # ..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//dummyprocess4xi.py
                symbolize2verb4xi(file2xi)
    
    print('=' *70)
    print("(STEP 0E/33) Verbalize4Xi: CREATED VERB-DOCUMENTS TO ", path2verbalize)
    # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//
    print('=' *70)
    
    
    print('=' *70)
    name2cluster = str(number2cluster)
    path2cluster = path2verbalize + name2cluster + '.html'    
    print("(STEP 1/33) Verbalize4Xi: CREATING CLUSTER DOCUMENT ", path2cluster)
    # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2215.html
    print('=' *70)    
    # ---------------------------------------------------------------------   
    # PRODUCE CLUSTER4XI.HTML
    # ---------------------------------------------------------------------     
    try:
        # ClusterColor4Xi = {
        #       TENSE 1       TENSE 2       TENSE 3       TENSE 4   #SUPER #CLUSTER                             # VERB EXAMPLES
        #       BASE          STRONGER      LIGHTER       STRONGEST     INDEX NAME 
        #        1:  {1: '#7C6142', 2: '#473117', 3: '#C7B5A0', 4: '#241505', 5: 4, 6: 'operations'},   
        #        ...
        #        23: {1: '#946025', 2: '#704D25', 3: '#9B6323', 4: '#4E361B', 5: 4, 6: 'filing'},   
        #        ...
        #        33: {1: '#000000', 2: '#000000', 3: '#FFFFFF', 4: '#000000', 5: 0, 6: 'FREE'}    
        

        try:
            # -----------------------------------------------------------------
            # (STEP 39/33) SAVE LINK TO CLUSTER NAME
            # -----------------------------------------------------------------
            key2alpha = 'c'
            print("(STEP 39A/33) KEY2ALPHA: ", key2alpha, " PATH2CLUSTER: ", path2cluster, " KB2LINK4URL: ", kb2link4url)
            # c  PATH2CLUSTER:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2215.html 
            if kb2link4url == {}:
                kb2link4url[key2alpha] = {}
                kb2link4url[key2alpha] [name2cluster] = path2cluster
                print("(STEP 39C/33) kb2link4url[", key2alpha, "][", name2cluster, "]: ", kb2link4url[key2alpha] [name2cluster])
                # kb2link4url[ c ][ 2215 ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2215.html
                                             
            else:
                keys2alpha = kb2link4url.keys()
                if key2alpha in keys2alpha:                                     
                    kb2link4url[key2alpha] [name2cluster] = path2cluster
                    print("(STEP 39E/33) kb2link4url[", key2alpha, "][", name2cluster, "]: ", kb2link4url[key2alpha] [name2cluster])
                    # kb2link4url[ c ][ 2215 ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2215.html
                    
                else:
                    kb2link4url[key2alpha] = {}
                    kb2link4url[key2alpha] [name2cluster] = path2cluster
                    print("(STEP 39G/33) kb2link4url[", key2alpha, "][", name2cluster, "]: ", kb2link4url[key2alpha] [name2cluster])
                    # kb2link4url[ c ][ 2215 ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2215.html
                    
                       
        except:
            print("(STEP 39Z/33) *** FAILED TO SAVE LINK TO CLUSTER NAME ", path2cluster)
            # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2215.html
                 
        # -----------------------------------------------------------------
        # (STEP 40/33) OPEN CLUSTER HTML FILE
        # -----------------------------------------------------------------
        f2xi=open(path2cluster, 'w')    
        print("(STEP 40A/33) OK: OPENED FOR WRITING PATH2CLUSTER: ", path2cluster, time4xi()) 
        # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2215.html
        
        try:    
            # -----------------------------------------------------------------
            # (STEP 40A/33) WRITE HEADERS
            # -----------------------------------------------------------------         
            f2xi.write('<!DOCTYPE HTML>' + '\n')
            f2xi.write('<html>' + '\n')
            f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
            f2xi.write('<style type="text/css" media="all">' + '\n')
            f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
            f2xi.write('</style>' + '\n') 
            f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
            f2xi.write('<body>' + '\n')
            
            f2xi.write('<h3>' + 'Cluster Info ' + '[Rel 7.21] ' + '[' + time4xi() + ']' + '</h3>' + '\n')
                                                    
        except:
            print("(STEP 40ZA/33) *** FAILED TO WRITE HEADERS ", time4xi()) 
             
        try:    
            # -----------------------------------------------------------------
            # (STEP 40B/33) WRITE START OF TABLE
            # ----------------------------------------------------------------- 
            f2xi.write('<table>' + '\n')
            f2xi.write('<tbody>' + '\n')
            f2xi.write('<tr>' + '\n') 
            f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n')
            f2xi.write('</td>' + '\n')
            f2xi.write('</tr>' + '\n')
                                            
        except:
            print("(STEP 40ZB/33) *** FAILED TO WRITE START OF TABLE ", time4xi())         
        
        keys2cluster = ClusterColor4Xi.keys()
        print("(STEP 40A/33) KEYS2CLUSTER: ", keys2cluster)
        # dict_keys([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33])
        
        for key2cluster in sorted(keys2cluster):
            f2xi.write('<tr>' + '\n') 
            f2xi.write('<td>' + '\n') 
            f2xi.write('<h4>' + 'Cluster' + '</h4>' + '\n')
            f2xi.write('</td>' + '\n')
            f2xi.write('<td>' + '\n') 
            f2xi.write('<h4>' + str(key2cluster) + '</h4>' + '\n')
            f2xi.write('</td>' + '\n')  
            f2xi.write('</tr>' + '\n')
                 
            kb2use4cluster = ClusterColor4Xi[key2cluster]
            print("(STEP 40B/33) KB2USECLUSTER: ", kb2use4cluster)
            # {1: '#7C6142', 2: '#473117', 3: '#C7B5A0', 4: '#241505', 5: 4, 6: 'operations'}
            
            keys2use4cluster = kb2use4cluster.keys()
            print("(STEP 40C/33) KEYS2USE4CLUSTER: ", keys2use4cluster)
            # dict_keys([1, 2, 3, 4, 5, 6])
  
            for key2use4cluster in sorted(keys2use4cluster):
                print("(STEP 40D/33) KEY2USE4CLUSTER: ", key2use4cluster)
                # 1 ... 6                         
                if key2use4cluster < 5:
                    # -----------------------------------------------------------------
                    # (STEP 41/33) WRITE CLUSTER TENSE COLOR
                    # -----------------------------------------------------------------
                    f2xi.write('<tr>' + '\n')
                    f2xi.write('<td>' + '\n') 
                    f2xi.write('cluster-tense' + str(key2use4cluster) + '-color' + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('<td bgcolor=' + str(kb2use4cluster[key2use4cluster]) + '>' + '\n')
                    f2xi.write('</td>' + '\n')  
                    f2xi.write('</tr>' + '\n')
                    # cluster-tense1-color: #7C6142
                    # cluster-tense2-color: #473117
                    # cluster-tense3-color: #C7B5A0
                    # cluster-tense4-color: #241505
                if key2use4cluster == 5:
                    # -----------------------------------------------------------------
                    # (STEP 42/33) WRITE SUPER INFO
                    # -----------------------------------------------------------------                                        
                    key2link4super = int(kb2use4cluster[key2use4cluster])
                    print("(STEP 42A/33) KEY2LINK4SUPER: ", key2link4super)
                    # 4
                    kb2use4super = SuperClusterColor4Xi[key2link4super]
                    print("(STEP 42B/33) KB2USE4SUPER: ", kb2use4super)
                    # {1: '#9292A1', 2: '#2A2A5C', 3: '#B2B2BF', 4: '#11112B', 5: 'operations'}   
                    keys2use4super = kb2use4super.keys()
                    print("(STEP 42C/33) KEYS2USE4SUPER: ", keys2use4super)
                    # dict_keys([1, 2, 3, 4, 5])
                    
                    for key2use4super in sorted(keys2use4super):
                        if key2use4super < 5:
                            try:
                                print("(STEP 42E/33) KEY2USE4SUPER: ", key2use4super)
                                # 1 ... 4
                                f2xi.write('<tr>' + '\n')
                                
                                f2xi.write('<td>' + '\n')
                                f2xi.write('super-color' + str(key2use4super) + '\n')
                                f2xi.write('</td>' + '\n')
                                
                                f2xi.write('<td bgcolor=' + str(kb2use4super[key2use4super]) + '>' + '\n')
                                f2xi.write('</td>' + '\n')
                                
                                f2xi.write('</tr>' + '\n')
                                # super-color1: '#9292A1'
                                # super-color2: '#2A2A5C'
                                # super-color3: '#B2B2BF'
                                # super-color4: '#11112B'
                                
                            except:
                                print("(STEP 42Z1/33) *** FAILED IN SUPER PROCESSING, KEY2USE4SUPER: ", key2use4super, " FOR: ", path2cluster) 
                        if key2use4super == 5:
                            try:
                                print("(STEP 42F/33) KEY2USE4SUPER: ", key2use4super, " SUPER-NAME: ", str(kb2use4super[key2use4super]))
                                # 5
                                f2xi.write('<tr>' + '\n')
                                
                                f2xi.write('<td>' + '\n')
                                f2xi.write('super-name' + '\n')
                                f2xi.write('</td>' + '\n')
                                
                                f2xi.write('<td>' + '\n')
                                f2xi.write(str(kb2use4super[key2use4super]) + '\n')
                                f2xi.write('</td>' + '\n')
                                
                                f2xi.write('</tr>' + '\n')
                                # 'operations'
                            except:
                                print("(STEP 42Z2/33) *** FAILED IN SUPER-CLUSTER PROCESSING FOR: ", path2cluster)     
                             
                if key2use4cluster == 6:
                    print("(STEP 45E8/33) KEY2USE: ", key2use4cluster)
                    # 6
                    f2xi.write('<tr>' + '\n')
                    f2xi.write('<td>' + '\n')
                    f2xi.write('cluster-name' + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('<td>' + '\n')
                    f2xi.write(str(kb2use4cluster[key2use4cluster]) + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('</tr>' + '\n')
                    # cluster-name: operations
                    if str(kb2use4cluster[key2use4cluster]) == 'FREE':
                        print("(STEP 42Z3/33) ** WARNING ** FREE CLUSTER - KEY2USE4CLUSTER: ", key2use4cluster)
            
        # ------------------------------------------------------------------
        # (STEP 47/33) WRITE REST
        # ------------------------------------------------------------------
        f2xi.write('<tr>' + '\n') 
        f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n') 
        f2xi.write('</td>' + '\n') 
        f2xi.write('</tr>' + '\n') 
        f2xi.write('</tbody>' + '\n') 
        f2xi.write('</table>' + '\n') 
        
        f2xi.write('</body>' + '\n')
        f2xi.write('</html>' + '\n')
             
        # ---------------------------------------------------------------------   
        # (STEP 48/33) CLOSE OUTPUT HTML FILE
        # ---------------------------------------------------------------------           
        print("(STEP 48A/33) OK - PRODUCED OUTPUT FILE: ", path2cluster)
        f2xi.close()
        print("(STEP 48B/33) OK - CLOSED PATH2VERB: ", path2cluster)
            
            
    except:
        print("(STEP 40Z1/33) *** FAILED TO PRODUCE CLUSTER HTML FILE ***")
        
                
    print('=' *70)
    name2super = str(number2super)
    path2super = path2verbalize + name2super + '.html'    
    print("(STEP 2/33) Verbalize4Xi: CREATING SUPER DOCUMENT ", path2super)
    # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2230.html
    print('=' *70)    
    # ---------------------------------------------------------------------   
    # PRODUCE SUPER4XI.HTML
    # ---------------------------------------------------------------------     
    try:
        # SuperClusterColor4Xi = {
        #     NETWORK-CENTRIC OPERATIONS AT REMOTE AND DEMANDING THEATERS
        #     TENSE 1       TENSE 2       TENSE 3       TENSE 4       #NAME                 
        #     BASE          STRONGER      LIGHTER       STRONGEST
        # 1:  {1: '#9BA2A2', 2: '#8E9292', 3: '#DAE1E1', 4: '#DAE1E2', 5: 'theater'},       
        # 2:  {1: '#0080FF', 2: '#045FB4', 3: '#58ACFA', 4: '#084B8A', 5: 'network'},                      
        # 3:  {1: '#7C6142', 2: '#473117', 3: '#C7B5A0', 4: '#241505', 5: 'manoeuvres'},                    
        # 4:  {1: '#9292A1', 2: '#2A2A5C', 3: '#B2B2BF', 4: '#11112B', 5: 'operations'},            
        # 5:  {1: '#0B6138', 2: '#234736', 3: '#06C36B', 4: '#13613C', 5: 'successes'},                              
        # 6:  {1: '#F55A5A', 2: '#BF2828', 3: '#F77676', 4: '#640A0A', 5: 'challenges'},
        # 7:  {1: '#EE4545', 2: '#D72727', 3: '#C41B1B', 4: '#E13939', 5: 'problems'}, 
        # 8:  {1: '#DE9ABC', 2: '#BF749A', 3: '#B3698E', 4: '#9C5378', 5: 'miscellaneous'}                           
        # }  
                                                
        try:
            # -----------------------------------------------------------------
            # (STEP 49/33) SAVE LINK TO SUPER NAME
            # -----------------------------------------------------------------
            key2alpha = 's'
            print("(STEP 49A/33) KEY2ALPHA: ", key2alpha, " PATH2SUPER: ", path2super)
            # 
            if kb2link4url == {}:
                
                kb2link4url[key2alpha] = {}
                kb2link4url[key2alpha] [name2super] = path2super
                print("(STEP 49C/33) kb2link4url[", key2alpha, "][", name2super, "]: ", kb2link4url[key2alpha] [name2super])
                # kb2link4url[ s ][ 2230 ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2230.html
                                            
            else:
                keys2alpha = kb2link4url.keys()
                if key2alpha in keys2alpha:                                     
                    kb2link4url[key2alpha] [name2super] = path2super
                    print("(STEP 49E/33) kb2link4url[", key2alpha, "][", name2super, "]: ", kb2link4url[key2alpha] [name2super])
                    # kb2link4url[ s ][ 2230 ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2230.html
                    
                else:
                    kb2link4url[key2alpha] = {}
                    kb2link4url[key2alpha] [name2super] = path2super
                    print("(STEP 49G/33) kb2link4url[", key2alpha, "][", name2super, "]: ", kb2link4url[key2alpha] [name2super])
                    # kb2link4url[ s ][ 2230 ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2230.html
                    
        except:
            print("(STEP 49Z/33) *** FAILED TO SAVE LINK TO SUPER NAME ", path2super)
            # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2230.html 
                                        
        # -----------------------------------------------------------------
        # (STEP 50A/33) OPEN SUPER HTML FILE
        # -----------------------------------------------------------------
          
        f2xi=open(path2super, 'w')    
        print("(STEP 50/33) OK: OPENED FOR WRITING PATH2SUPER: ", path2super, time4xi()) 
        # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//2230.html
                                        
        # -----------------------------------------------------------------
        # (STEP 50B/33) WRITE HEADERS
        # -----------------------------------------------------------------
        try:      
            f2xi.write('<!DOCTYPE HTML>' + '\n')
            f2xi.write('<html>' + '\n')
            f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
            f2xi.write('<style type="text/css" media="all">' + '\n')
            f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
            f2xi.write('</style>' + '\n') 
            f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
            f2xi.write('<body>' + '\n')
            
            f2xi.write('<h3>' + 'SuperCluster Info ' + '[Rel 7.21] ' + '[' + time4xi() + ']' + '</h3>' + '\n')
        except:
            print("(STEP 50ZB/33) *** FAILED TO WRITE WRITE HEADERS ", time4xi()) 
        try:    
            # -----------------------------------------------------------------
            # (STEP 50C/33) WRITE START OF TABLE
            # ----------------------------------------------------------------- 
            f2xi.write('<table>' + '\n')
            f2xi.write('<tbody>' + '\n')
            f2xi.write('<tr>' + '\n') 
            f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n')
            f2xi.write('</td>' + '\n')
            f2xi.write('</tr>' + '\n')
                                             
        except:
            print("(STEP 50ZC/33) *** FAILED TO WRITE START OF TABLE ", time4xi()) 
        
        keys2super = SuperClusterColor4Xi.keys()
        print("(STEP 50A/33) KEYS2SUPER: ", keys2super)
        # 1 ... 8
        
        for key2super in sorted(keys2super):
            f2xi.write('<tr>' + '\n')
            f2xi.write('<td>' + '\n')
            f2xi.write('<h4>' + 'SuperCluster' + '</h4>' + '\n')
            f2xi.write('</td>' + '\n')
            f2xi.write('<td>' + '\n')
            f2xi.write('<h4>' + str(key2super) + '</h4>' + '\n')
            f2xi.write('</td>' + '\n')
            f2xi.write('</tr>' + '\n')
                  
            kb2use4super = SuperClusterColor4Xi[key2super]
            print("(STEP 50B/33) KB2USESUPER: ", kb2use4super)
            # {1: '#9BA2A2', 2: '#8E9292', 3: '#DAE1E1', 4: '#DAE1E2', 5: 'theater'}
            
            keys2use4super = kb2use4super.keys()
            print("(STEP 50C/33) KEYS2USE4SUPER: ", keys2use4super)
            # 1 ... 5 
            for key2use4super in sorted(keys2use4super):
                print("(STEP 50D/33) KEY2USE4SUPER: ", key2use4super)
                # 1 ... 5                         
                if key2use4super < 5:
                    # -----------------------------------------------------------------
                    # (STEP 51/33) WRITE SUPER TENSE COLOR
                    # -----------------------------------------------------------------
                    f2xi.write('<tr>' + '\n')
                    f2xi.write('<td>' + '\n')
                    f2xi.write('super-tense' + str(key2use4super) + '-color' + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('<td bgcolor=' + str(kb2use4super[key2use4super]) + '>' + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('</tr>' + '\n')
                    # super-tense1-color: '#9BA2A2'
                    # super-tense2-color: '#8E9292'
                    # super-tense3-color: '#DAE1E1'
                    # super-tense4-color: '#DAE1E2'
                if key2use4super == 5:
                    # -----------------------------------------------------------------
                    # (STEP 52/33) WRITE SUPER NAME
                    # -----------------------------------------------------------------                                        
                    f2xi.write('<tr>' + '\n')
                    f2xi.write('<td>' + '\n')
                    f2xi.write('super' + '-name' + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('<td>' + '\n')
                    f2xi.write(kb2use4super[key2use4super] + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('</tr>' + '\n')
                    # super1-name: 'theater'

            
        # ------------------------------------------------------------------
        # (STEP 57/33) WRITE REST OF SUPER
        # ------------------------------------------------------------------
        f2xi.write('<tr>' + '\n') 
        f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n') 
        f2xi.write('</td>' + '\n') 
        f2xi.write('</tr>' + '\n') 
        f2xi.write('</tbody>' + '\n') 
        f2xi.write('</table>' + '\n') 
             
        f2xi.write('</body>' + '\n')
        f2xi.write('</html>' + '\n')
             
        # ---------------------------------------------------------------------   
        # (STEP 58/33) CLOSE SUPER OUTPUT HTML FILE
        # ---------------------------------------------------------------------           
        print("(STEP 58A/33) OK - PRODUCED OUTPUT FILE: ", path2super)
        f2xi.close()
        print("(STEP 58B/33) OK - CLOSED PATH2VERB: ", path2super)
            
            
    except:
        print("(STEP 50Z1/33) *** FAILED TO PRODUCE SUPER HTML FILE ***") 
        
        
    # -----------------------------------------------------------------
    # (STEP 60/33) OPEN INDEXVERB4XI HTML FILE
    # -----------------------------------------------------------------
    try:
        path2index = path2verbalize + 'index2symbol4xi' + '.html'  
        
        f2xi=open(path2index, 'w')    
        print("(STEP 60/33) OK: OPENED FOR WRITING PATH2INDEX: ", path2index, time4xi()) 
        # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//symbolize2verb4xi//index2symbol4xi.html
        
        f2xi.write('<!DOCTYPE HTML>' + '\n')
        f2xi.write('<html>' + '\n')
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<style type="text/css" media="all">' + '\n')
        f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
        f2xi.write('</style>' + '\n') 
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<body>' + '\n')
        f2xi.write('<img id="logo4dragonxi" src="../../../../../web/images/jpg/logo4dragonxi.jpg" alt="yourDragonXi" width="240" height="120">' + '\n')
        f2xi.write('<h3>' + 'Symbols for Verbs ' + '[Rel 7.21] ' + '[' + time4xi() + ']' + '</h3>' + '\n')
        
        keys2alpha = kb2link4url.keys()
        print("(STEP 60A/33) KEYS2ALPHA: ", keys2alpha) 
        # dict_keys(['c', '_', 'z', 's'])
        
        for key2alpha in sorted(keys2alpha):
            f2xi.write('<h4>' + '[' + str(key2alpha) + ']' + '</h4>' + '\n')
            # <h4>[a]</h4>
            
            kb2use4link = kb2link4url[key2alpha]
            print("(STEP 60B/33) KB2USE4LINK: ", kb2use4link) 
            # <br /><b>&raquo;</b><a href="..//symbolize2verb4xi//3.html" target="_blank">3</a>
            # ...
            # <br /><b>&raquo;</b><a href="..//symbolize2verb4xi//125.html" target="_blank">125</a>
  
            keys2use4link = kb2use4link.keys()
            print("(STEP 60C/33) KEYS2USE4INDEX: ", keys2use4link)
            # dict_keys(['activate', 'ace', 'abbreviate', 'acquire', 'abstract', 'add', 'acknowledge', 'append', 'accept', 'act', 'analyze', 'assert'])
            for key2use4link in sorted(keys2use4link):
                print("(STEP 60D/33) KEY2USE4LINK: ", key2use4link)
                # abbreviate
                       
                print("(STEP 60E/33) BASE2LINK: ", base2link)
                # ..//symbolize2verb4xi//
                
                source2link = kb2link4url[key2alpha] [key2use4link]
                text2search = base2link[4:]
                print("(STEP 60F/33) TEXT2SEARCH: ", text2search)
                # symbolize2verb4xi//
                index2pattern = str.find(source2link,text2search)
                print("(STEP 60G/33) INDEX2PATTERN: ", index2pattern)
                # 56
                if index2pattern == -1:
                    print("(STEP 60Z1/33) *** ERROR SOURCE2LINK: ", source2link, " MISSING BASE2LINK: ", base2link)
                    #     
                else:
                    name2link = source2link[index2pattern+len(text2search):]            
                    text2search = ".html"
                    index2extension = str.find(name2link,text2search)
                    if index2extension == -1:
                        pass
                    else:
                        header2link = name2link[0:index2extension]    
                    f2xi.write('<br /><b>&raquo;</b><a href="' + base2link + name2link + '" target="_blank">' + header2link + '</a>\n')  
                    # <br /><b>&raquo;</b><a href="..//symbolize2verb4xi//125.html" target="_blank">125</a>
                    
        # ------------------------------------------------------------------
        # (STEP 67/33) WRITE REST FOR INDEX4VERB
        # ------------------------------------------------------------------
        
        f2xi.write('</body>' + '\n')
        f2xi.write('</html>' + '\n')
             
        # ---------------------------------------------------------------------   
        # (STEP 68/33) CLOSE INDEX4VERB OUTPUT HTML FILE
        # ---------------------------------------------------------------------           
        print("(STEP 68A/33) OK - PRODUCED OUTPUT FILE: ", path2index)
        f2xi.close()
        print("(STEP 68B/33) OK - CLOSED PATH2VERB: ", path2index)

    except:
        print("(STEP 69Z1/33) *** FAILED TO PRODUCE INDEX4VERB HTML FILE ***")                
        
         
#</function4xi>    
    
        
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   symbolize2verb4xi.txt
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of symbolize2verb4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>
